function populateBlogID()
{
  var blogNS        = "http://www.exitspace.net/blog/";
  var ds			= rdfStore.getSource("profile");
  var RDF	        = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                                .getService(Components.interfaces.nsIRDFService);
  var serverRDFList = Components.classes["@mozilla.org/rdf/container;1"]
                                .getService(Components.interfaces.nsIRDFContainer);

  var serverList    = document.getElementById("blogIDs");
  var mozblogNS     = RDF.GetResource("http://www.exitspace.net/blog");
  var defaultValue  = null;
  var count         = 0;

  serverRDFList.Init(ds, mozblogNS);
  var serverEnumerator = serverRDFList.GetElements();
  var defaultIndex     = getRDFAttribute(ds, mozblogNS, blogNS+"BlogIDdefaultIndex");
  try {
  	defaultIndex       = parseInt(defaultIndex);
  } catch (e) { dump ("Error getting the starting blogID index: "+e); defaultIndex = 0 }

  while (serverEnumerator.hasMoreElements()) {
    var blogIdItem = serverEnumerator.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var blogID     = blogIdItem.Value;
    var blogName   = getRDFAttribute(ds, blogIdItem, blogNS+"siteName");
	serverList.insertItemAt(count, blogName, blogID);
	if(count++ == defaultIndex)
	  defaultValue = blogID;
  }

  serverList.selectedIndex = defaultIndex;
  if (postListBox) { // update the previous post box
    postListBox.changeChannel(defaultValue);
  }
}

/*******************************************************************************************************
 *the previous post box object
 *******************************************************************************************************/
var prevPostBox = function()
{
  this.init();
}

prevPostBox.prototype = {
  ds      : null,
  postBox : null,
  init : function()
  {
    this.ds = rdfStore.getSource("blogHistory");
    this.postBox = document.getElementById("prevBlogPostList");
    this.postBox.setAttribute("ref", "http://www.exitspace.net/blog/posts");
    this.postBox.database.AddDataSource(this.ds);
    this.postBox.builder.rebuild();
  },
  changeChannel : function(channel)
  {
    document.getElementById("blogChannel")
            .setAttributeNS("http://www.w3.org/1999/02/22-rdf-syntax-ns#", "type", channel);
    this.postBox.builder.rebuild();
  },
  get selectedResource()
  {
    var selectedRS = null;
    if (this.postBox.currentIndex != -1) {
      try {
        selectedRS =  this.postBox.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder)
                          .getResourceAtIndex(this.postBox.currentIndex);
      } catch(e) { dump("prevPostBox.selectedResource(): "+e+"\n\n"); }
    } else {
      falseSelection = true;
    }
    return selectedRS;
  },
  deleteSelection : function()
  {
    var RDF            = Components.classes['@mozilla.org/rdf/rdf-service;1']
                                   .getService(Components.interfaces.nsIRDFService);
    var RDFContainer   = Components.classes["@mozilla.org/rdf/container;1"]
                                   .getService(Components.interfaces.nsIRDFContainer);
    var localStorage   = new localStore(null);

    var seleResource = this.selectedResource;
    if (seleResource) {
      localStorage.deleteFile(getRDFAttribute(this.ds, seleResource, "http://www.exitspace.net/blog/filename"));
      RDFContainer.Init(this.ds, RDF.GetResource('http://www.exitspace.net/blog/posts'));
      var preds = this.ds.ArcLabelsOut(seleResource);
      while (preds.hasMoreElements()) {
        var predicate = preds.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        this.ds.Unassert(seleResource, predicate, this.ds.GetTarget(seleResource, predicate, true));
      }
      RDFContainer.RemoveElement(seleResource, true);
      saveDatasource(this.ds);
    }
      //this.selectIndex(0);
  },
  selectIndex : function(newIndex)
  {
    if (newIndex != -1) {
      if (this.hasEntries()) {
        this.postBox.treeBoxObject.selection.select(newIndex);
      }
    } else {
      this.postBox.treeBoxObject.selection.select(-1);
    }
  },
  count : function()
  {
    var numAvailable = 0;
    var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
                                 .getService(Components.interfaces.nsIRDFContainer);
    try {
      RDFContainer.Init(this.ds, RDF.GetResource('http://www.exitspace.net/blog/posts'));
      numAvailable = RDFContainer.GetCount();
    } catch (e) {}
    return numAvailable;
  },
  hasEntries : function()
  {
    // see if there is an entry for this particular channel
    var entryBool = false;
    try {
       entryBool = this.ds.hasArcIn(RDF.GetResource(document.getElementById("blogIDs").selectedItem.value),
                                    RDF.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type"));
    } catch (e) {}
    return entryBool;
  }
}

/*******************************************************************************************************
 *the category manager object
 *******************************************************************************************************/
var categoryManager = function() {
  this.init();
}

categoryManager.prototype = {
  RDF    : null,
  blogNS : null,

  init : function()
  {
    this.blogNS            = "http://www.exitspace.net/blog/";
    this.RDF               = Components.classes['@mozilla.org/rdf/rdf-service;1']
                                        .getService(Components.interfaces.nsIRDFService);
    this.RDFContainer      = Components.classes["@mozilla.org/rdf/container;1"]
                                       .getService(Components.interfaces.nsIRDFContainer);
    this.RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
                                       .getService(Components.interfaces.nsIRDFContainerUtils);
  },

  addCategory : function(blogAccount, newCategory)
  {
    var ds            = rdfStore.getSource("profile");
    var blogIDNS      = this.RDF.GetResource(blogAccount);
    var BlogCateNS    = ds.GetTarget(blogIDNS, RDF.GetResource(this.blogNS+"category"), true);
    if (BlogCateNS) {
      BlogCateNS = BlogCateNS.QueryInterface(Components.interfaces.nsIRDFResource);
    } else {
      BlogCateNS      = RDF.GetResource(blogAccount + "#category");
      ds.Assert(blogIDNS, RDF.GetResource(this.blogNS+"category"), BlogCateNS, true);
    }
    if (!this.RDFContainerUtils.IsContainer(ds, BlogCateNS)) {
      this.RDFContainer = this.RDFContainerUtils.MakeSeq(ds, BlogCateNS);
    }

    this.RDFContainer.Init(ds, BlogCateNS);
    var categoryNS = this.RDF.GetResource(blogAccount + "/" + newCategory);
    var index = this.RDFContainer.IndexOf(categoryNS);
    if (index == -1) {// none existed
      this.RDFContainer.AppendElement(categoryNS);
      setRDFAttribute(ds, categoryNS, this.blogNS+"categoryName", newCategory);
    } else
      alert ("Category already exist!");
    var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    localRDS.Flush();
    ds = null;
  },

  delCategory : function(blogAccount, selectedCategory)
  {
    var ds            = rdfStore.getSource("profile");
    var blogIDNS      = this.RDF.GetResource(blogAccount);
    var BlogCateNS    = ds.GetTarget(blogIDNS, RDF.GetResource(this.blogNS+"category"), true);
    if (BlogCateNS) {
      BlogCateNS = BlogCateNS.QueryInterface(Components.interfaces.nsIRDFResource);
      if (this.RDFContainerUtils.IsContainer(ds, BlogCateNS)) {
        this.RDFContainer.Init(ds, BlogCateNS);
        var categoryNS = this.RDF.GetResource(blogAccount + "/" + selectedCategory);
        var index = this.RDFContainer.IndexOf(categoryNS);
        if (index != -1) {// entry exist
          this.RDFContainer.RemoveElementAt(index, true);
          ds.Unassert(categoryNS, this.RDF.GetResource(this.blogNS+"categoryName"),
                      this.RDF.GetLiteral(selectedCategory));
        }
      }
    }
    var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    localRDS.Flush();
    ds = null;
  }
}