///////////////////////////////////////
// Password manager utility functions
//////////////////////////////////////

function loadPassword(url, user)
{
  var passwordManagerInternal = GetPasswordManagerInternal();
  var host = {value:""};
  var username = {value:""};
  var password = {value:""};
  if (!passwordManagerInternal)
    return false;
  try {
    passwordManagerInternal.findPasswordEntry(url, user, "", host, username, password);
    return password.value;
  } catch (e) {}
  return false;
}

function GetPasswordManagerInternal()
{
  var passwdMgrInternal;
  try {
    passwdMgrInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                                  .createInstance(Components.interfaces.nsIPasswordManagerInternal);
  } catch (e) {
    dump (e);
  }
  return passwdMgrInternal;
}

function GetPasswordManager()
{
  var gPasswordManager;
  var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
  if (passwordManager)
    gPasswordManager = passwordManager.QueryInterface(Components.interfaces.nsIPasswordManager);
  return gPasswordManager;
}

function savePassword(url, user, password)
{
  if (!url || !user || !password)
    return false;
  var passwordManager = GetPasswordManager();
  if (passwordManager)
  {
    // Remove existing entry
    // (Note: there is no method to update a password for an existing entry)
    try {
      passwordManager.removeUser(url, user);
    } catch (e) {}

    // If SavePassword is true, add new password
    try {
      passwordManager.addUser(url, user, password);
    } catch (e) {}

    return true;
  }
  return false;
}