/* *
 * This file contain all the frontend handlers code which may call other function to complete the task.
 * */

/**************************************************************************************************
 * Main toolbar commands
 **************************************************************************************************/

// const kIOServiceProgID = "@mozilla.org/network/io-service;1"; // Taken from /comm/content/communicator/utilityOverlay.js

function CheckOnlineStatus(){
  // This function verify the connection state. If OffLine then ask the user to go Online or not.
  // If the user say Yes then the browser state is change to Online and return True else return false.
  var ioService = Components.classes[kIOServiceProgID]
                            .getService(Components.interfaces.nsIIOService);
  var LocalStrings = document.getElementById("bundle_MozBlog");
  if (ioService.offline) {
      if (confirm(LocalStrings.getString("MozBlog.ConfirmOnLine"))) ioService.offline = false;
  }                          
  return !ioService.offline;
}

function mozBlogLoadURL(uri)
{
  document.getElementById("content").loadURI ( uri, "http://localhost/" );  //WithFlags ( uri , null , null )
}

function editPost()
{
  SetDocumentEditable(true);
  editorHandle.focus();
}

function publishPost()
{
  var currentPostID = null;
  var postPublished = false;
  var ds            = rdfStore.getSource("blogHistory");
  var resource      = postListBox.selectedResource;
  if (resource) {
    currentPostID   = getRDFAttribute(ds, resource, "http://www.exitspace.net/blog/postid");
    if (currentPostID != -1) postPublished = true;
  }

  postStore.snapState();
  var blogTitle     = document.getElementById("doctitle").value;
  var blogContent   = cleanSource(editorHandle.content);
  var currentBlogID = document.getElementById("blogIDs").selectedItem.value;
  if (currentBlogID != "http://localhost/") {
    if (CheckOnlineStatus()) {
      blogContent   = extractThenUploadImage(blogContent);
      recentPublish = true;
      switch (getAccountType()) {
        case "movabletype" : postPublished ? metaWeblogEditPost(currentPostID, blogTitle, blogContent, true) :
                                             metaWeblogNewPost(blogTitle, blogContent, true); break;
        case "radio"       : postPublished ? metaWeblogEditPost(currentPostID, blogTitle, blogContent, true) :
                                             metaWeblogNewPost(blogTitle, blogContent, true); break;
        default            : postPublished ? bloggerEditPost(currentPostID, blogContent, true) :
                                             bloggerNewPost(blogContent, true);
      }
    }
  } else {
    postStore.saveToDisk();
  }
}

// Already in editorExtension.js | Mike Check this!

function showHideFormatBar()
{
  var discussFormatBar = document.getElementById("discussFormatBar");
  var LocalStrings = document.getElementById("bundle_MozBlog");
  if (discussFormatBar.collapsed == true) {
    discussFormatBar.collapsed = false;
    discussFormatbarOpen = true;
    document.getElementById("discuss-open-formatbar")
      .setAttribute("label",LocalStrings.getString("MozBlog.HideFormatToolbar"));
  } else {
    discussFormatBar.collapsed = true;
    discussFormatbarOpen = false;
    document.getElementById("discuss-open-formatbar")
      .setAttribute("label",LocalStrings.getString("MozBlog.ShowFormatToolbar"));
  }
}

function deletePost()
{
  var msg           = "";
  var currentBlogID = document.getElementById("blogIDs").selectedItem.value;
  var currentPostID = null;
  var ds            = rdfStore.getSource("blogHistory");
  var resource      = postListBox.selectedResource;
  var LocalStrings = document.getElementById("bundle_MozBlog");
  if (resource)
    currentPostID   = getRDFAttribute(ds, resource, "http://www.exitspace.net/blog/postid");

  if (currentPostID == -1)
    msg             = LocalStrings.getString("MozBlog.LocalPost");
  else
    msg = currentPostID;
  if (currentPostID != null)
    if (confirm(LocalStrings.getString("MozBlog.SureToDeletePost") + msg)) {
      if (currentPostID == -1 || currentBlogID == "http://localhost/") {
        postListBox.deleteSelection();
      } else {
        bloggerDeletePost(currentPostID);
      }
    }
  if (postListBox.hasEntries) postListBox.selectIndex(0);
}

function chooseChannel()
{
  // update the new default channel
  var currentBlogID = document.getElementById("blogIDs").selectedItem.value;
  document.getElementById("ViewBlogbtn").setAttribute("value", currentBlogID);
  var RDF           = Components.classes['@mozilla.org/rdf/rdf-service;1']
                                .getService(Components.interfaces.nsIRDFService);
  var ds            = rdfStore.getSource("profile");
  var newIndex      = RDF.GetLiteral(document.getElementById("blogIDs").selectedIndex);
  var espaceNS      = "http://www.exitspace.net/blog";
  updateAssertion(ds, espaceNS, espaceNS+"/BlogIDdefaultIndex", newIndex);
  saveDatasource(ds);
  postListBox.changeChannel(currentBlogID); // update the previous post list
  //Added to prevent from seeing the post of another BlogID
  if (postListBox.hasEntries) postListBox.selectIndex(0);
}

/**************************************************************************************************
 * Recent Post Box commands
 **************************************************************************************************/

function createNewPost()
{
  saveLastPost();
  postListBox.selectIndex(-1);
  clearField();
  try {
    postStore.clearState();
    postStore.saveToDisk();
    newlyCreatedFile = true;
  } catch (e) { dump("saveToDisk failed: "+e); }
  postListBox.selectIndex(0);
}

function loadWebSite(uri)
{
  document.getElementById("content").loadURI(uri);  //WithFlags ( uri , null , null )
}

function loadCurrentBlog()
{
  var uri = document.getElementById("blogIDs").selectedItem.value;
  document.getElementById("content").loadURI(uri);  //WithFlags ( uri , null , null )
}

function synchronize()
{
  var RDF                = Components.classes['@mozilla.org/rdf/rdf-service;1']
                                     .getService(Components.interfaces.nsIRDFService);
  var blogNS             = "http://www.exitspace.net/blog/";
  var currentBlogID      = document.getElementById("blogIDs").selectedItem.value;
  var blogIDNS           = RDF.GetResource(currentBlogID);
  var BlogSrvNS          = RDF.GetResource(blogNS+"blogServer");
  var ds                 = rdfStore.getSource("profile");
  var BlogSrvContainerNS = ds.GetTarget(blogIDNS, BlogSrvNS, true)
                             .QueryInterface(Components.interfaces.nsIRDFResource);
  var retrievePost       = parseInt(getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"retrieveNum"));
  ds                     = null;
  if (!retrievePost)
    retrievePost         = 5;
  switch (getAccountType()) {
    case "movabletype" : metaWeblogGetRecentPosts(retrievePost); break;
    case "radio"       : metaWeblogGetRecentPosts(retrievePost); break;
    default            : bloggerGetRecentPosts(retrievePost);
  }
}